import 'package:at_commons/at_builders.dart';

class PkamVerbBuilder implements VerbBuilder {
  /// Enrollment approvalId generated by server for APKAM
  String? enrollmentlId;

  String? signingAlgo;

  String? hashingAlgo;

  /// base64encoded signed challenge
  late String signature;

  @override
  String buildCommand() {
    StringBuffer serverCommandBuffer = StringBuffer('pkam');
    if (signingAlgo != null && signingAlgo!.isNotEmpty) {
      serverCommandBuffer.write(':signingAlgo:$signingAlgo');
    }
    if (hashingAlgo != null && hashingAlgo!.isNotEmpty) {
      serverCommandBuffer.write(':hashingAlgo:$hashingAlgo');
    }
    if (enrollmentlId != null && enrollmentlId!.isNotEmpty) {
      serverCommandBuffer.write(':enrollmentId:$enrollmentlId');
    }
    return (serverCommandBuffer..write(':$signature\n')).toString();
  }

  @override
  bool checkParams() {
    return signature.isNotEmpty;
  }
}
